<?php

require_once "factorize.php";

class FactorizerTest extends PHPUnit_Framework_TestCase {

    public function testZero() {
        $this->theFactorsOf_ShouldBe(0, []);
    }

    function testOne() {
        $this->theFactorsOf_ShouldBe(1, []);
    }

    function testTwo() {
        $this->theFactorsOf_ShouldBe(2, [2]);
    }

    function testMinusTwo() {
        $this->theFactorsOf_ShouldBe(-2, []);
    }

    function testFour() {
        $this->theFactorsOf_ShouldBe(4, [2, 2]);
    }

    function testSix() {
        $this->theFactorsOf_ShouldBe(6, [2, 3]);
    }

    function testEight() {
        $this->theFactorsOf_ShouldBe(8, [2, 2, 2]);
    }

    function testNine() {
        $this->theFactorsOf_ShouldBe(9, [3, 3]);
    }

    function testTwentyFive() {
        $this->theFactorsOf_ShouldBe(25, [5, 5]);
    }

    function testWhatever() {
        $this->theFactorsOf_ShouldBe(126, [2, 3, 3, 7]);
    }

    function testReallyBigNumber() {
        $this->theFactorsOf_ShouldBe(1263123622, [2, 7393, 85427]);
    }

    private function theFactorsOf_ShouldBe($int, $array) {
        $this->assertEquals($array, factorize($int));
    }

}
 